diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/internet-trace-helper.cc ns-3.40/src/internet/helper/internet-trace-helper.cc
--- ns-3.39/src/internet/helper/internet-trace-helper.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/internet-trace-helper.cc	2023-09-27 13:30:37.650839000 -0700
@@ -57,17 +57,16 @@
 void
 PcapHelperForIpv4::EnablePcapIpv4(std::string prefix, Ipv4InterfaceContainer c)
 {
-    for (Ipv4InterfaceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
-        std::pair<Ptr<Ipv4>, uint32_t> pair = *i;
-        EnablePcapIpv4(prefix, pair.first, pair.second, false);
+        EnablePcapIpv4(prefix, (*i).first, (*i).second, false);
     }
 }
 
 void
 PcapHelperForIpv4::EnablePcapIpv4(std::string prefix, NodeContainer n)
 {
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
@@ -95,7 +94,7 @@
 {
     NodeContainer n = NodeContainer::GetGlobal();
 
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetId() != nodeid)
@@ -198,10 +197,9 @@
                                              std::string prefix,
                                              Ipv4InterfaceContainer c)
 {
-    for (Ipv4InterfaceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
-        std::pair<Ptr<Ipv4>, uint32_t> pair = *i;
-        EnableAsciiIpv4Internal(stream, prefix, pair.first, pair.second, false);
+        EnableAsciiIpv4Internal(stream, prefix, (*i).first, (*i).second, false);
     }
 }
 
@@ -231,7 +229,7 @@
                                              std::string prefix,
                                              NodeContainer n)
 {
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
@@ -299,7 +297,7 @@
 {
     NodeContainer n = NodeContainer::GetGlobal();
 
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetId() != nodeid)
@@ -339,17 +337,16 @@
 void
 PcapHelperForIpv6::EnablePcapIpv6(std::string prefix, Ipv6InterfaceContainer c)
 {
-    for (Ipv6InterfaceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
-        std::pair<Ptr<Ipv6>, uint32_t> pair = *i;
-        EnablePcapIpv6(prefix, pair.first, pair.second, false);
+        EnablePcapIpv6(prefix, (*i).first, (*i).second, false);
     }
 }
 
 void
 PcapHelperForIpv6::EnablePcapIpv6(std::string prefix, NodeContainer n)
 {
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<Ipv6> ipv6 = node->GetObject<Ipv6>();
@@ -377,7 +374,7 @@
 {
     NodeContainer n = NodeContainer::GetGlobal();
 
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetId() != nodeid)
@@ -480,10 +477,9 @@
                                              std::string prefix,
                                              Ipv6InterfaceContainer c)
 {
-    for (Ipv6InterfaceContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
-        std::pair<Ptr<Ipv6>, uint32_t> pair = *i;
-        EnableAsciiIpv6Internal(stream, prefix, pair.first, pair.second, false);
+        EnableAsciiIpv6Internal(stream, prefix, (*i).first, (*i).second, false);
     }
 }
 
@@ -513,7 +509,7 @@
                                              std::string prefix,
                                              NodeContainer n)
 {
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<Ipv6> ipv6 = node->GetObject<Ipv6>();
@@ -580,7 +576,7 @@
 {
     NodeContainer n = NodeContainer::GetGlobal();
 
-    for (NodeContainer::Iterator i = n.Begin(); i != n.End(); ++i)
+    for (auto i = n.Begin(); i != n.End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetId() != nodeid)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/internet-trace-helper.h ns-3.40/src/internet/helper/internet-trace-helper.h
--- ns-3.39/src/internet/helper/internet-trace-helper.h	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/internet-trace-helper.h	2023-09-27 13:30:37.650839000 -0700
@@ -18,10 +18,11 @@
 #ifndef INTERNET_TRACE_HELPER_H
 #define INTERNET_TRACE_HELPER_H
 
+#include "ipv4-interface-container.h"
+#include "ipv6-interface-container.h"
+
 #include "ns3/assert.h"
-#include "ns3/ipv4-interface-container.h"
 #include "ns3/ipv4.h"
-#include "ns3/ipv6-interface-container.h"
 #include "ns3/ipv6.h"
 #include "ns3/trace-helper.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv4-global-routing-helper.h ns-3.40/src/internet/helper/ipv4-global-routing-helper.h
--- ns-3.39/src/internet/helper/ipv4-global-routing-helper.h	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv4-global-routing-helper.h	2023-09-27 13:30:37.650839000 -0700
@@ -19,7 +19,8 @@
 #ifndef IPV4_GLOBAL_ROUTING_HELPER_H
 #define IPV4_GLOBAL_ROUTING_HELPER_H
 
-#include "ns3/ipv4-routing-helper.h"
+#include "ipv4-routing-helper.h"
+
 #include "ns3/node-container.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv4-interface-container.cc ns-3.40/src/internet/helper/ipv4-interface-container.cc
--- ns-3.39/src/internet/helper/ipv4-interface-container.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv4-interface-container.cc	2023-09-27 13:30:37.650839000 -0700
@@ -32,9 +32,7 @@
 void
 Ipv4InterfaceContainer::Add(const Ipv4InterfaceContainer& other)
 {
-    for (InterfaceVector::const_iterator i = other.m_interfaces.begin();
-         i != other.m_interfaces.end();
-         i++)
+    for (auto i = other.m_interfaces.begin(); i != other.m_interfaces.end(); i++)
     {
         m_interfaces.push_back(*i);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv4-list-routing-helper.cc ns-3.40/src/internet/helper/ipv4-list-routing-helper.cc
--- ns-3.39/src/internet/helper/ipv4-list-routing-helper.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv4-list-routing-helper.cc	2023-09-27 13:30:37.650839000 -0700
@@ -30,9 +30,7 @@
 
 Ipv4ListRoutingHelper::~Ipv4ListRoutingHelper()
 {
-    for (std::list<std::pair<const Ipv4RoutingHelper*, int16_t>>::iterator i = m_list.begin();
-         i != m_list.end();
-         ++i)
+    for (auto i = m_list.begin(); i != m_list.end(); ++i)
     {
         delete i->first;
     }
@@ -40,8 +38,7 @@
 
 Ipv4ListRoutingHelper::Ipv4ListRoutingHelper(const Ipv4ListRoutingHelper& o)
 {
-    std::list<std::pair<const Ipv4RoutingHelper*, int16_t>>::const_iterator i;
-    for (i = o.m_list.begin(); i != o.m_list.end(); ++i)
+    for (auto i = o.m_list.begin(); i != o.m_list.end(); ++i)
     {
         m_list.emplace_back(const_cast<const Ipv4RoutingHelper*>(i->first->Copy()), i->second);
     }
@@ -63,9 +60,7 @@
 Ipv4ListRoutingHelper::Create(Ptr<Node> node) const
 {
     Ptr<Ipv4ListRouting> list = CreateObject<Ipv4ListRouting>();
-    for (std::list<std::pair<const Ipv4RoutingHelper*, int16_t>>::const_iterator i = m_list.begin();
-         i != m_list.end();
-         ++i)
+    for (auto i = m_list.begin(); i != m_list.end(); ++i)
     {
         Ptr<Ipv4RoutingProtocol> prot = i->first->Create(node);
         list->AddRoutingProtocol(prot, i->second);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv4-list-routing-helper.h ns-3.40/src/internet/helper/ipv4-list-routing-helper.h
--- ns-3.39/src/internet/helper/ipv4-list-routing-helper.h	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv4-list-routing-helper.h	2023-09-27 13:30:37.650839000 -0700
@@ -19,7 +19,7 @@
 #ifndef IPV4_LIST_ROUTING_HELPER_H
 #define IPV4_LIST_ROUTING_HELPER_H
 
-#include "ns3/ipv4-routing-helper.h"
+#include "ipv4-routing-helper.h"
 
 #include <list>
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv4-static-routing-helper.cc ns-3.40/src/internet/helper/ipv4-static-routing-helper.cc
--- ns-3.39/src/internet/helper/ipv4-static-routing-helper.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv4-static-routing-helper.cc	2023-09-27 13:30:37.650839000 -0700
@@ -97,7 +97,7 @@
     // We need to convert the NetDeviceContainer to an array of interface
     // numbers
     std::vector<uint32_t> outputInterfaces;
-    for (NetDeviceContainer::Iterator i = output.Begin(); i != output.End(); ++i)
+    for (auto i = output.Begin(); i != output.End(); ++i)
     {
         Ptr<NetDevice> nd = *i;
         int32_t interface = ipv4->GetInterfaceForDevice(nd);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv4-static-routing-helper.h ns-3.40/src/internet/helper/ipv4-static-routing-helper.h
--- ns-3.39/src/internet/helper/ipv4-static-routing-helper.h	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv4-static-routing-helper.h	2023-09-27 13:30:37.650839000 -0700
@@ -18,8 +18,9 @@
 #ifndef IPV4_STATIC_ROUTING_HELPER_H
 #define IPV4_STATIC_ROUTING_HELPER_H
 
+#include "ipv4-routing-helper.h"
+
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-routing-helper.h"
 #include "ns3/ipv4-static-routing.h"
 #include "ns3/ipv4.h"
 #include "ns3/net-device-container.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv6-address-helper.cc ns-3.40/src/internet/helper/ipv6-address-helper.cc
--- ns-3.39/src/internet/helper/ipv6-address-helper.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv6-address-helper.cc	2023-09-27 13:30:37.650839000 -0700
@@ -220,11 +220,7 @@
 Ipv6AddressHelper::Assign(const NetDeviceContainer& c)
 {
     NS_LOG_FUNCTION(this);
-    std::vector<bool> withConfiguration;
-    for (uint32_t i = 0; i < c.GetN(); ++i)
-    {
-        withConfiguration.push_back(true);
-    }
+    std::vector<bool> withConfiguration(c.GetN(), true);
     return Assign(c, withConfiguration);
 }
 
@@ -232,11 +228,7 @@
 Ipv6AddressHelper::Assign(const NetDeviceContainer& c, std::vector<bool> withConfiguration)
 {
     NS_LOG_FUNCTION(this);
-    std::vector<bool> onLink;
-    for (uint32_t i = 0; i < c.GetN(); ++i)
-    {
-        onLink.push_back(true);
-    }
+    std::vector<bool> onLink(c.GetN(), true);
     return Assign(c, withConfiguration, onLink);
 }
 
@@ -312,11 +304,7 @@
 Ipv6AddressHelper::AssignWithoutAddress(const NetDeviceContainer& c)
 {
     NS_LOG_FUNCTION(this);
-    std::vector<bool> withConfiguration;
-    for (uint32_t i = 0; i < c.GetN(); ++i)
-    {
-        withConfiguration.push_back(false);
-    }
+    std::vector<bool> withConfiguration(c.GetN(), false);
     return Assign(c, withConfiguration);
 }
 
@@ -324,13 +312,10 @@
 Ipv6AddressHelper::AssignWithoutOnLink(const NetDeviceContainer& c)
 {
     NS_LOG_FUNCTION(this);
-    std::vector<bool> withConfiguration;
-    std::vector<bool> onLink;
-    for (uint32_t i = 0; i < c.GetN(); ++i)
-    {
-        withConfiguration.push_back(true);
-        onLink.push_back(false);
-    }
+
+    std::vector<bool> withConfiguration(c.GetN(), true);
+    std::vector<bool> onLink(c.GetN(), false);
+
     return Assign(c, withConfiguration, onLink);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv6-interface-container.cc ns-3.40/src/internet/helper/ipv6-interface-container.cc
--- ns-3.39/src/internet/helper/ipv6-interface-container.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv6-interface-container.cc	2023-09-27 13:30:37.650839000 -0700
@@ -81,8 +81,7 @@
 void
 Ipv6InterfaceContainer::Add(const Ipv6InterfaceContainer& c)
 {
-    for (InterfaceVector::const_iterator it = c.m_interfaces.begin(); it != c.m_interfaces.end();
-         it++)
+    for (auto it = c.m_interfaces.begin(); it != c.m_interfaces.end(); it++)
     {
         m_interfaces.push_back(*it);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv6-list-routing-helper.cc ns-3.40/src/internet/helper/ipv6-list-routing-helper.cc
--- ns-3.39/src/internet/helper/ipv6-list-routing-helper.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv6-list-routing-helper.cc	2023-09-27 13:30:37.654839000 -0700
@@ -31,9 +31,7 @@
 
 Ipv6ListRoutingHelper::~Ipv6ListRoutingHelper()
 {
-    for (std::list<std::pair<const Ipv6RoutingHelper*, int16_t>>::iterator i = m_list.begin();
-         i != m_list.end();
-         ++i)
+    for (auto i = m_list.begin(); i != m_list.end(); ++i)
     {
         delete i->first;
     }
@@ -41,8 +39,7 @@
 
 Ipv6ListRoutingHelper::Ipv6ListRoutingHelper(const Ipv6ListRoutingHelper& o)
 {
-    std::list<std::pair<const Ipv6RoutingHelper*, int16_t>>::const_iterator i;
-    for (i = o.m_list.begin(); i != o.m_list.end(); ++i)
+    for (auto i = o.m_list.begin(); i != o.m_list.end(); ++i)
     {
         m_list.emplace_back(const_cast<const Ipv6RoutingHelper*>(i->first->Copy()), i->second);
     }
@@ -64,9 +61,7 @@
 Ipv6ListRoutingHelper::Create(Ptr<Node> node) const
 {
     Ptr<Ipv6ListRouting> list = CreateObject<Ipv6ListRouting>();
-    for (std::list<std::pair<const Ipv6RoutingHelper*, int16_t>>::const_iterator i = m_list.begin();
-         i != m_list.end();
-         ++i)
+    for (auto i = m_list.begin(); i != m_list.end(); ++i)
     {
         Ptr<Ipv6RoutingProtocol> prot = i->first->Create(node);
         list->AddRoutingProtocol(prot, i->second);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv6-list-routing-helper.h ns-3.40/src/internet/helper/ipv6-list-routing-helper.h
--- ns-3.39/src/internet/helper/ipv6-list-routing-helper.h	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/ipv6-list-routing-helper.h	2023-09-27 13:30:37.654839000 -0700
@@ -19,7 +19,7 @@
 #ifndef IPV6_LIST_ROUTING_HELPER_H
 #define IPV6_LIST_ROUTING_HELPER_H
 
-#include "ns3/ipv6-routing-helper.h"
+#include "ipv6-routing-helper.h"
 
 #include <list>
 #include <stdint.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv6-static-routing-helper.cc ns-3.40/src/internet/helper/ipv6-static-routing-helper.cc
--- ns-3.39/src/internet/helper/ipv6-static-routing-helper.cc	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/helper/ipv6-static-routing-helper.cc	2023-09-27 13:30:37.654839000 -0700
@@ -97,7 +97,7 @@
     // We need to convert the NetDeviceContainer to an array of interface
     // numbers
     std::vector<uint32_t> outputInterfaces;
-    for (NetDeviceContainer::Iterator i = output.Begin(); i != output.End(); ++i)
+    for (auto i = output.Begin(); i != output.End(); ++i)
     {
         Ptr<NetDevice> nd = *i;
         int32_t interface = ipv6->GetInterfaceForDevice(nd);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ipv6-static-routing-helper.h ns-3.40/src/internet/helper/ipv6-static-routing-helper.h
--- ns-3.39/src/internet/helper/ipv6-static-routing-helper.h	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/helper/ipv6-static-routing-helper.h	2023-09-27 13:30:37.654839000 -0700
@@ -18,8 +18,9 @@
 #ifndef IPV6_STATIC_ROUTING_HELPER_H
 #define IPV6_STATIC_ROUTING_HELPER_H
 
+#include "ipv6-routing-helper.h"
+
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-routing-helper.h"
 #include "ns3/ipv6-static-routing.h"
 #include "ns3/ipv6.h"
 #include "ns3/net-device-container.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/neighbor-cache-helper.h ns-3.40/src/internet/helper/neighbor-cache-helper.h
--- ns-3.39/src/internet/helper/neighbor-cache-helper.h	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/helper/neighbor-cache-helper.h	2023-09-27 13:30:37.654839000 -0700
@@ -20,16 +20,17 @@
 #ifndef NEIGHBOR_CACHE_HELPER_H
 #define NEIGHBOR_CACHE_HELPER_H
 
+#include "ipv4-interface-container.h"
+#include "ipv6-interface-container.h"
+
 #include "ns3/arp-cache.h"
 #include "ns3/arp-header.h"
 #include "ns3/arp-l3-protocol.h"
 #include "ns3/channel.h"
 #include "ns3/icmpv6-l4-protocol.h"
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-interface-container.h"
 #include "ns3/ipv4-interface.h"
 #include "ns3/ipv4-l3-protocol.h"
-#include "ns3/ipv6-interface-container.h"
 #include "ns3/ipv6-interface.h"
 #include "ns3/ipv6-l3-protocol.h"
 #include "ns3/net-device-container.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/rip-helper.cc ns-3.40/src/internet/helper/rip-helper.cc
--- ns-3.39/src/internet/helper/rip-helper.cc	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/helper/rip-helper.cc	2023-09-27 13:30:37.654839000 -0700
@@ -56,20 +56,18 @@
 {
     Ptr<Rip> rip = m_factory.Create<Rip>();
 
-    std::map<Ptr<Node>, std::set<uint32_t>>::const_iterator it = m_interfaceExclusions.find(node);
+    auto it = m_interfaceExclusions.find(node);
 
     if (it != m_interfaceExclusions.end())
     {
         rip->SetInterfaceExclusions(it->second);
     }
 
-    std::map<Ptr<Node>, std::map<uint32_t, uint8_t>>::const_iterator iter =
-        m_interfaceMetrics.find(node);
+    auto iter = m_interfaceMetrics.find(node);
 
     if (iter != m_interfaceMetrics.end())
     {
-        std::map<uint32_t, uint8_t>::const_iterator subiter;
-        for (subiter = iter->second.begin(); subiter != iter->second.end(); subiter++)
+        for (auto subiter = iter->second.begin(); subiter != iter->second.end(); subiter++)
         {
             rip->SetInterfaceMetric(subiter->first, subiter->second);
         }
@@ -90,7 +88,7 @@
 {
     int64_t currentStream = stream;
     Ptr<Node> node;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         node = (*i);
         Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
@@ -160,7 +158,7 @@
 void
 RipHelper::ExcludeInterface(Ptr<Node> node, uint32_t interface)
 {
-    std::map<Ptr<Node>, std::set<uint32_t>>::iterator it = m_interfaceExclusions.find(node);
+    auto it = m_interfaceExclusions.find(node);
 
     if (it == m_interfaceExclusions.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/rip-helper.h ns-3.40/src/internet/helper/rip-helper.h
--- ns-3.39/src/internet/helper/rip-helper.h	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/helper/rip-helper.h	2023-09-27 13:30:37.654839000 -0700
@@ -20,7 +20,8 @@
 #ifndef RIP_HELPER_H
 #define RIP_HELPER_H
 
-#include "ns3/ipv4-routing-helper.h"
+#include "ipv4-routing-helper.h"
+
 #include "ns3/node-container.h"
 #include "ns3/node.h"
 #include "ns3/object-factory.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ripng-helper.cc ns-3.40/src/internet/helper/ripng-helper.cc
--- ns-3.39/src/internet/helper/ripng-helper.cc	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/helper/ripng-helper.cc	2023-09-27 13:30:37.654839000 -0700
@@ -58,20 +58,18 @@
 {
     Ptr<RipNg> ripng = m_factory.Create<RipNg>();
 
-    std::map<Ptr<Node>, std::set<uint32_t>>::const_iterator it = m_interfaceExclusions.find(node);
+    auto it = m_interfaceExclusions.find(node);
 
     if (it != m_interfaceExclusions.end())
     {
         ripng->SetInterfaceExclusions(it->second);
     }
 
-    std::map<Ptr<Node>, std::map<uint32_t, uint8_t>>::const_iterator iter =
-        m_interfaceMetrics.find(node);
+    auto iter = m_interfaceMetrics.find(node);
 
     if (iter != m_interfaceMetrics.end())
     {
-        std::map<uint32_t, uint8_t>::const_iterator subiter;
-        for (subiter = iter->second.begin(); subiter != iter->second.end(); subiter++)
+        for (auto subiter = iter->second.begin(); subiter != iter->second.end(); subiter++)
         {
             ripng->SetInterfaceMetric(subiter->first, subiter->second);
         }
@@ -92,7 +90,7 @@
 {
     int64_t currentStream = stream;
     Ptr<Node> node;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         node = (*i);
         Ptr<Ipv6> ipv6 = node->GetObject<Ipv6>();
@@ -162,7 +160,7 @@
 void
 RipNgHelper::ExcludeInterface(Ptr<Node> node, uint32_t interface)
 {
-    std::map<Ptr<Node>, std::set<uint32_t>>::iterator it = m_interfaceExclusions.find(node);
+    auto it = m_interfaceExclusions.find(node);
 
     if (it == m_interfaceExclusions.end())
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/ripng-helper.h ns-3.40/src/internet/helper/ripng-helper.h
--- ns-3.39/src/internet/helper/ripng-helper.h	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/helper/ripng-helper.h	2023-09-27 13:30:37.654839000 -0700
@@ -20,7 +20,8 @@
 #ifndef RIPNG_HELPER_H
 #define RIPNG_HELPER_H
 
-#include "ns3/ipv6-routing-helper.h"
+#include "ipv6-routing-helper.h"
+
 #include "ns3/node-container.h"
 #include "ns3/node.h"
 #include "ns3/object-factory.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/arp-l3-protocol.cc ns-3.40/src/internet/model/arp-l3-protocol.cc
--- ns-3.39/src/internet/model/arp-l3-protocol.cc	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/model/arp-l3-protocol.cc	2023-09-27 13:30:37.654839000 -0700
@@ -131,7 +131,7 @@
 ArpL3Protocol::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (CacheList::iterator i = m_cacheList.begin(); i != m_cacheList.end(); ++i)
+    for (auto i = m_cacheList.begin(); i != m_cacheList.end(); ++i)
     {
         Ptr<ArpCache> cache = *i;
         cache->Dispose();
@@ -160,7 +160,7 @@
 ArpL3Protocol::FindCache(Ptr<NetDevice> device)
 {
     NS_LOG_FUNCTION(this << device);
-    for (CacheList::const_iterator i = m_cacheList.begin(); i != m_cacheList.end(); i++)
+    for (auto i = m_cacheList.begin(); i != m_cacheList.end(); i++)
     {
         if ((*i)->GetDevice() == device)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/arp-l3-protocol.h ns-3.40/src/internet/model/arp-l3-protocol.h
--- ns-3.39/src/internet/model/arp-l3-protocol.h	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/model/arp-l3-protocol.h	2023-09-27 13:30:37.654839000 -0700
@@ -19,8 +19,9 @@
 #ifndef ARP_L3_PROTOCOL_H
 #define ARP_L3_PROTOCOL_H
 
+#include "ipv4-header.h"
+
 #include "ns3/address.h"
-#include "ns3/ipv4-header.h"
 #include "ns3/net-device.h"
 #include "ns3/ptr.h"
 #include "ns3/random-variable-stream.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/candidate-queue.cc ns-3.40/src/internet/model/candidate-queue.cc
--- ns-3.39/src/internet/model/candidate-queue.cc	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/model/candidate-queue.cc	2023-09-27 13:30:37.654839000 -0700
@@ -58,12 +58,10 @@
 std::ostream&
 operator<<(std::ostream& os, const CandidateQueue& q)
 {
-    typedef CandidateQueue::CandidateList_t List_t;
-    typedef List_t::const_iterator CIter_t;
     const CandidateQueue::CandidateList_t& list = q.m_candidates;
 
     os << "*** CandidateQueue Begin (<id, distance, LSA-type>) ***" << std::endl;
-    for (CIter_t iter = list.begin(); iter != list.end(); iter++)
+    for (auto iter = list.begin(); iter != list.end(); iter++)
     {
         os << "<" << (*iter)->GetVertexId() << ", " << (*iter)->GetDistanceFromRoot() << ", "
            << (*iter)->GetVertexType() << ">" << std::endl;
@@ -101,10 +99,10 @@
 {
     NS_LOG_FUNCTION(this << vNew);
 
-    CandidateList_t::iterator i = std::upper_bound(m_candidates.begin(),
-                                                   m_candidates.end(),
-                                                   vNew,
-                                                   &CandidateQueue::CompareSPFVertex);
+    auto i = std::upper_bound(m_candidates.begin(),
+                              m_candidates.end(),
+                              vNew,
+                              &CandidateQueue::CompareSPFVertex);
     m_candidates.insert(i, vNew);
 }
 
@@ -152,7 +150,7 @@
 CandidateQueue::Find(const Ipv4Address addr) const
 {
     NS_LOG_FUNCTION(this);
-    CandidateList_t::const_iterator i = m_candidates.begin();
+    auto i = m_candidates.begin();
 
     for (; i != m_candidates.end(); i++)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/global-route-manager-impl.cc ns-3.40/src/internet/model/global-route-manager-impl.cc
--- ns-3.39/src/internet/model/global-route-manager-impl.cc	2023-07-05 14:23:47.841427300 -0700
+++ ns-3.40/src/internet/model/global-route-manager-impl.cc	2023-09-27 13:30:37.654839000 -0700
@@ -62,9 +62,8 @@
 std::ostream&
 operator<<(std::ostream& os, const SPFVertex::ListOfSPFVertex_t& vs)
 {
-    typedef SPFVertex::ListOfSPFVertex_t::const_iterator CIter_t;
     os << "{";
-    for (CIter_t iter = vs.begin(); iter != vs.end();)
+    for (auto iter = vs.begin(); iter != vs.end();)
     {
         os << (*iter)->m_vertexId;
         if (++iter != vs.end())
@@ -133,7 +132,7 @@
 
     // find this node from all its parents and remove the entry of this node
     // from all its parents
-    for (ListOfSPFVertex_t::iterator piter = m_parents.begin(); piter != m_parents.end(); piter++)
+    for (auto piter = m_parents.begin(); piter != m_parents.end(); piter++)
     {
         // remove the current vertex from its parent's children list. Check
         // if the size of the list is reduced, or the child<->parent relation
@@ -255,7 +254,7 @@
         NS_LOG_LOGIC("Index to SPFVertex's parent is out-of-range.");
         return nullptr;
     }
-    ListOfSPFVertex_t::const_iterator iter = m_parents.begin();
+    auto iter = m_parents.begin();
     while (i-- > 0)
     {
         iter++;
@@ -302,11 +301,10 @@
 SPFVertex::GetRootExitDirection(uint32_t i) const
 {
     NS_LOG_FUNCTION(this << i);
-    typedef ListOfNodeExit_t::const_iterator CIter_t;
 
     NS_ASSERT_MSG(i < m_ecmpRootExits.size(),
                   "Index out-of-range when accessing SPFVertex::m_ecmpRootExits!");
-    CIter_t iter = m_ecmpRootExits.begin();
+    auto iter = m_ecmpRootExits.begin();
     while (i-- > 0)
     {
         iter++;
@@ -376,7 +374,7 @@
     NS_LOG_FUNCTION(this << n);
     uint32_t j = 0;
 
-    for (ListOfSPFVertex_t::const_iterator i = m_children.begin(); i != m_children.end(); i++, j++)
+    for (auto i = m_children.begin(); i != m_children.end(); i++, j++)
     {
         if (j == n)
         {
@@ -436,8 +434,7 @@
 GlobalRouteManagerLSDB::~GlobalRouteManagerLSDB()
 {
     NS_LOG_FUNCTION(this);
-    LSDBMap_t::iterator i;
-    for (i = m_database.begin(); i != m_database.end(); i++)
+    for (auto i = m_database.begin(); i != m_database.end(); i++)
     {
         NS_LOG_LOGIC("free LSA");
         GlobalRoutingLSA* temp = i->second;
@@ -457,8 +454,7 @@
 GlobalRouteManagerLSDB::Initialize()
 {
     NS_LOG_FUNCTION(this);
-    LSDBMap_t::iterator i;
-    for (i = m_database.begin(); i != m_database.end(); i++)
+    for (auto i = m_database.begin(); i != m_database.end(); i++)
     {
         GlobalRoutingLSA* temp = i->second;
         temp->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
@@ -500,8 +496,7 @@
     //
     // Look up an LSA by its address.
     //
-    LSDBMap_t::const_iterator i;
-    for (i = m_database.begin(); i != m_database.end(); i++)
+    for (auto i = m_database.begin(); i != m_database.end(); i++)
     {
         if (i->first == addr)
         {
@@ -518,8 +513,7 @@
     //
     // Look up an LSA by its address.
     //
-    LSDBMap_t::const_iterator i;
-    for (i = m_database.begin(); i != m_database.end(); i++)
+    for (auto i = m_database.begin(); i != m_database.end(); i++)
     {
         GlobalRoutingLSA* temp = i->second;
         // Iterate among temp's Link Records
@@ -573,8 +567,7 @@
 GlobalRouteManagerImpl::DeleteGlobalRoutes()
 {
     NS_LOG_FUNCTION(this);
-    NodeList::Iterator listEnd = NodeList::End();
-    for (NodeList::Iterator i = NodeList::Begin(); i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
         Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
@@ -621,8 +614,7 @@
     // Walk the list of nodes looking for the GlobalRouter Interface.  Nodes with
     // global router interfaces are, not too surprisingly, our routers.
     //
-    NodeList::Iterator listEnd = NodeList::End();
-    for (NodeList::Iterator i = NodeList::Begin(); i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
 
@@ -648,7 +640,7 @@
 
         for (uint32_t j = 0; j < numLSAs; ++j)
         {
-            GlobalRoutingLSA* lsa = new GlobalRoutingLSA();
+            auto lsa = new GlobalRoutingLSA();
             //
             // This is the call to actually fetch a Link State Advertisement from the
             // router.
@@ -704,8 +696,7 @@
     // Walk the list of nodes in the system.
     //
     NS_LOG_INFO("About to start SPF calculation");
-    NodeList::Iterator listEnd = NodeList::End();
-    for (NodeList::Iterator i = NodeList::Begin(); i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
         //
@@ -1561,9 +1552,7 @@
     // ID corresponding to the root vertex.  This is the one we're going to write
     // the routing information to.
     //
-    NodeList::Iterator i = NodeList::Begin();
-    NodeList::Iterator listEnd = NodeList::End();
-    for (; i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
         //
@@ -1727,9 +1716,7 @@
     // ID corresponding to the root vertex.  This is the one we're going to write
     // the routing information to.
     //
-    NodeList::Iterator i = NodeList::Begin();
-    NodeList::Iterator listEnd = NodeList::End();
-    for (; i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
         //
@@ -1849,9 +1836,7 @@
     // the node at the root of the SPF tree.  This is the node for which we are
     // building the routing table.
     //
-    NodeList::Iterator i = NodeList::Begin();
-    NodeList::Iterator listEnd = NodeList::End();
-    for (; i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
 
@@ -1938,9 +1923,7 @@
     // ID corresponding to the root vertex.  This is the one we're going to write
     // the routing information to.
     //
-    NodeList::Iterator i = NodeList::Begin();
-    NodeList::Iterator listEnd = NodeList::End();
-    for (; i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
         //
@@ -2082,9 +2065,7 @@
     // ID corresponding to the root vertex.  This is the one we're going to write
     // the routing information to.
     //
-    NodeList::Iterator i = NodeList::Begin();
-    NodeList::Iterator listEnd = NodeList::End();
-    for (; i != listEnd; i++)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
     {
         Ptr<Node> node = *i;
         //
